package ch.inf3.indexation.model;

import java.io.Serializable;
import java.util.Date;
import javax.persistence.DiscriminatorColumn;
import javax.persistence.DiscriminatorType;
import javax.persistence.DiscriminatorValue;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Inheritance;
import javax.persistence.InheritanceType;
import javax.persistence.NamedQuery;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;
import org.hibernate.annotations.GenericGenerator;

@Entity
@Table(name = "Bookmark")
@NamedQuery(name = "Bookmark.findAll", query = "SELECT t FROM Bookmark t")
@Inheritance(strategy = InheritanceType.SINGLE_TABLE)
@DiscriminatorColumn(name = "internalType", discriminatorType = DiscriminatorType.STRING)
@DiscriminatorValue(value = "text/x-moz-place/default")
public class Bookmark implements Serializable {

    @Id
    @GeneratedValue(generator = "uuid")
    @GenericGenerator(name = "uuid", strategy = "uuid2")
    protected String uuid;

    protected String guid;
    protected String title;
    protected Integer index;

    @Temporal(TemporalType.TIMESTAMP)
    protected Date dateAdded;

    @Temporal(TemporalType.TIMESTAMP)
    protected Date lastModified;

    protected Integer id;
    protected Integer typeCode;
    protected String type;
    protected String uri;
    protected String iconuri;

    protected String internalType;
    protected String internalPrefix;

    @Temporal(TemporalType.TIMESTAMP)
    protected Date lastRetrieved;
    protected Integer lastStatus;
    protected String lastUri;

    public String getUuid() {
        return uuid;
    }

    public void setUuid(String uuid) {
        this.uuid = uuid;
    }

    public String getGuid() {
        return guid;
    }

    public void setGuid(String guid) {
        this.guid = guid;
    }

    public String getTitle() {
        return title;
    }

    public void setTitle(String title) {
        this.title = title;
    }

    public Integer getIndex() {
        return index;
    }

    public void setIndex(Integer index) {
        this.index = index;
    }

    public Date getDateAdded() {
        return dateAdded;
    }

    public void setDateAdded(Date dateAdded) {
        this.dateAdded = dateAdded;
    }

    public Date getLastModified() {
        return lastModified;
    }

    public void setLastModified(Date lastModified) {
        this.lastModified = lastModified;
    }

    public Integer getId() {
        return id;
    }

    public void setId(Integer id) {
        this.id = id;
    }

    public Integer getTypeCode() {
        return typeCode;
    }

    public void setTypeCode(Integer typeCode) {
        this.typeCode = typeCode;
    }

    public String getType() {
        return type;
    }

    public void setType(String type) {
        this.type = type;
        this.internalType = type + "/default";
    }

    public String getUri() {
        return uri;
    }

    public void setUri(String uri) {
        this.uri = uri;
    }

    public String getIconuri() {
        return iconuri;
    }

    public void setIconuri(String iconuri) {
        this.iconuri = iconuri;
    }

    public String getInternalPrefix() {
        return internalPrefix;
    }

    public void setInternalPrefix(String internalPrefix) {
        this.internalPrefix = internalPrefix;
    }

    public String getInternalType() {
        return internalType;
    }

    public Date getLastRetrieved() {
        return lastRetrieved;
    }

    public void setLastRetrieved(Date lastRetrieved) {
        this.lastRetrieved = lastRetrieved;
    }

    public Integer getLastStatus() {
        return lastStatus;
    }

    public void setLastStatus(Integer lastStatus) {
        this.lastStatus = lastStatus;
    }

    public String getLastUri() {
        return lastUri;
    }

    public void setLastUri(String lastUri) {
        this.lastUri = lastUri;
    }

    @Override
    public String toString() {
        return "Bookmark{"
                + "uuid=" + uuid
                + ", guid=" + guid
                + ", title=" + title
                + ", id=" + id
                + ", uri=" + uri
                + ", internalType="
                + internalType
                + ", internalPrefix=" + internalPrefix
                + '}';
    }
}
